import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.util.Random;

//pole vahet, kas appletina vi applicationina kivitada.. ritab teha sama asja..

public class Katsetus extends JApplet implements ActionListener {
    Container contPanel;
    CompPanel hiireUnistus;
    MegaLaevandus shipData;
    JPanel composePanel, playPanel;

    public static void main(String s[]){
	JFrame frame = new JFrame("SwingiFreim");

	frame.addWindowListener(new WindowAdapter(){
		public void windowClosing(WindowEvent e){
		    System.exit(0);
		}
	    }); 
	//Well.. it seems like we have just made an empty window...
	//Now it is time to draw something inside that window...
	Katsetus megakatse = new Katsetus();
	megakatse.joonistaMagedus(frame.getContentPane());
		
	//fits added things to the window.. or fits the window.. whatever..
	frame.pack();
	//Finally, we have to make that frame visible too... **
	frame.setVisible(true);
    }
    
    //some applets features like init for example :)
    public void init(){
	joonistaMagedus(getContentPane());
	System.out.println("joonistaMagedus is over");
    }
    //and getAppletInfo
    public String getAppletInfo() {
	System.out.println("Someone is curious :)");
	return("Martin Ott Javat katsetamas");
    }

    void joonistaMagedus(Container joonistuskoht){
       contPanel = joonistuskoht;
       joonistuskoht.setLayout(new BorderLayout());
       
	shipData = new MegaLaevandus();

	composePanel = createComposingPanel();
	joonistuskoht.add(composePanel,BorderLayout.CENTER);

	playPanel = createPlayingPanel();
    }
    
    JPanel createComposingPanel(){
    
       hiireUnistus = new CompPanel(shipData);
	hiireUnistus.setOpaque(true);
	hiireUnistus.setPreferredSize(new Dimension(300,300));
	hiireUnistus.setBorder(BorderFactory.createLineBorder(Color.black));
	
	JButton pisinupp = new JButton("Valmis");
	pisinupp.setActionCommand("asetatud");
	pisinupp.addActionListener(this);

	JToolBar toolBar=new JToolBar();
	ShipButton naljanupp;

	for(int n=1, m=4 ; n<5 ; n++, m--){
	    naljanupp = new ShipButton(new Ship(n,1),m);
	    naljanupp.setVerticalTextPosition(AbstractButton.CENTER);
	    naljanupp.setHorizontalTextPosition(AbstractButton.RIGHT);
	    naljanupp.setActionCommand("pyyamind");
	    naljanupp.addActionListener(hiireUnistus);
	    toolBar.add(naljanupp);
	}

       JPanel paneel = new JPanel();	
	paneel.setLayout(new BorderLayout());
	paneel.add(toolBar, BorderLayout.NORTH);
	paneel.add(hiireUnistus,BorderLayout.CENTER);
	paneel.add(pisinupp,BorderLayout.SOUTH);
	
	return(paneel);
    }

    JPanel createPlayingPanel(){
       MegaLaevandus compData = new MegaLaevandus(10, 10);
       Random gen = new Random();
       for(int m=4, c=1; m>=1; m--, c++ ){
           Ship laiv=new Ship(m,1);
           for(int n=0; n<c; n++){
               if(gen.nextInt(2)==1)
               laiv.rotate();
               while(compData.asetaLaev(laiv, gen.nextInt(10), gen.nextInt(10))==0){
                   if(Math.random()>=0.5)
                       laiv.rotate();
               }
           }
       }
       ViewingPanel viewingPanel = new ViewingPanel(shipData);
       ShootingPanel shPanel = new ShootingPanel(compData);
       
       //Its just too late to think some better way... too bad :(
       Lollus unisus = new Lollus();
       unisus.spanel=shPanel;
       unisus.vpanel=viewingPanel;
       //Just made a class that remembers two panels.. and makes accesing them easier...
       
       JPanel paneel = new JPanel();
       paneel.setLayout(new GridLayout(1,2));
       paneel.add(viewingPanel);
       paneel.add(shPanel);
       return(paneel);
    }

    //well.. lets have a look about the actions performed
    public void actionPerformed(ActionEvent e){
       if(e.getActionCommand().equals("asetatud")){
          contPanel.removeAll();
          contPanel.add(playPanel);
          contPanel.validate();
       }else{
	   System.out.println(e);
	}
    }

}
