import java.util.*;

//Integer laivuke = (Integer)laivukesed.get(waterTable[whereX][whereY].contents);
//if(laivuke.largerThan(1)){
//    System.out.println("Pihtas!");
//    laivukesed.put(waterTable[whereX][whereY].contents,
//		   new Int(laivuke.intValue()-1));
//}else{
//    System.out.println("Phjas!");
//    laivukesed.remove(waterTable[whereX][whereY].contents);
//}

public class MegaLaevandus {

    class Square{
	boolean bombarded=false;
	Integer contents;

    }

    public Integer numberOfShips = new Integer(0);
    Map laivukesed = new HashMap();
    private Square[][] waterTable;

    MegaLaevandus(){
	waterTable=new Square[9][9];
	if (laivukesed==null)
	    laivukesed = new HashMap();
    }
    
    MegaLaevandus(int n){
	waterTable=new Square[n][n];
	if (laivukesed==null)
	    laivukesed = new HashMap();
    }
    
    MegaLaevandus(int m, int n){
	waterTable=new Square[m][n];
	if (laivukesed==null)
	    laivukesed = new HashMap();
    }

    public int asetaLaev(int pikkus, int laius, int x, int y){
	if( mahub(pikkus, laius, x, y) ){
	    numberOfShips = new Integer(numberOfShips.intValue() + 1);
	    Integer laiv = (Integer)laivukesed.get(numberOfShips);
	    laivukesed.put(numberOfShips, new Integer(pikkus*laius));	    

	    for(int m=x; m<pikkus+x; m++){
		for (int n=y; n<laius+y; n++){
		    if(waterTable[m][n]==null)
			waterTable[m][n] = new Square();

		    if (waterTable[m][n].contents==null){
			waterTable[m][n].contents = numberOfShips;}
		    else {
			System.out.println("Weird.. ");
			waterTable[m][n].contents = numberOfShips;}
		}
	    }

	    return(pikkus*laius);
	}
	return(0);
    }

    public Integer shootAt(int targetX, int targetY){
	System.out.println();
	//Igaks juhuks siia ks if..
	if(waterTable[targetX][targetY]==null){
	    waterTable[targetX][targetY] = new Square();
	    System.out.println("waterTable"+targetX+targetY+" was pointing to nowhere");
	}

	if(waterTable[targetX][targetY].bombarded){
    	    System.out.println("waterTable"+targetX+targetY+".bombarded is true");
	    return(null);
	}

	waterTable[targetX][targetY].bombarded=true;
	System.out.println("waterTable"+targetX+targetY+".bombarded was just set to true");
	return(waterTable[targetX][targetY].contents);


    }

    void tryki(){
	for(int n=0; n<waterTable.length; n++){
	    for(int m=0; m<waterTable[n].length; m++){
		if (waterTable[n][m]==null) System.out.print("0");
		else System.out.print(waterTable[n][m].contents);
	    }
	System.out.println();
	}
	System.out.println(laivukesed);
    }

    public boolean mahub(int pikkus, int laius, int x, int y){

	for(int m=x-1; m<=x+pikkus; m++){
	    for(int n=y-1;n<=x+laius;n++){
		if(( m>=0 && m<waterTable.length) && ( n>=0 && n<waterTable[m].length )){
		    if(waterTable[m][n]==null)
			continue;
		    if( waterTable[m][n].contents!=null){
			return(false);
		    }
		}
	    }
	}
	return(true);
    }
}
